Unit afb2e_p;
interface
uses
SysUtils, Math, { Delphi }
LStruct, Lfunc, UTAFSI_p;

procedure afb2e(var A :Array of Extended; MA :Integer; N :Integer;
                ML :Integer; MU :Integer; var NLEAD :Array of Integer;
                var RCOND :Extended; var Z :Array of Extended;
                var IERR :Integer);

implementation

procedure afb2e(var A :Array of Extended; MA :Integer; N :Integer;
                ML :Integer; MU :Integer; var NLEAD :Array of Integer;
                var RCOND :Extended; var Z :Array of Extended;
                var IERR :Integer);
var
I,I0,I1,J,J0,J1,JJ,JU,JZ,K,KB,KP1,L,LL,LM,M,MM,NM1 :Integer;
ANORM,EK,S,SM,T,WK,WKM,X,YNORM :Extended;
label
_10,_20,_30,_40,_50,_60,_70,_80,_90,_100,_110,_120,_130,_140,_150,_160,
_170,_180,_190,_200,_210,_220,_230,_240,_250,_260,_270,_280,_290,_300,
_310,_320,_330,_340,_350,_360,_370,_380,_390,_400,_410,_420,_430,_440,
_450,_460,_470,_480,_490,_500,_510,_520,_530,_540,_550,_560,_570,_580,
_590,_600,_610,_620,_630,_640,_650,_660,_670,_680,_690,_700,_710,_720,
_730,_740,_750,_760,_770,_780,_790,_800,_810,_820,_830,_840,_850,_860,
_870,_880,_890;
begin
RCOND := 0.0e0;
X := 0.0e0;
_10:
if ( N >= 1 ) and ( MA >= 1 ) 
 then goto _20;
IERR := 65;
UTAFSI('A','F','B','2','E',IERR);
goto _890;
_20:
IERR := 0;
M := ML + MU + 1;
for I:=1 to N do
 begin
  J0 := Max0(1,I-ML);
  J1 := Min0(N,I+MU);
  for J:=J0 to J1 do
   begin
    K := J - I + ML + 1;
    Z[J-1] := A[(I-1)+(K-1)*MA];
_30:
   end;
  for J:=J0 to J1 do
   begin
    A[(I-1)+(J-1)*MA] := Z[J-1];
_40:
   end;
_50:
 end;
ANORM := 0.e0;
for J:=1 to N do
 begin
  I0 := Max0(1,J-MU);
  I1 := Min0(N,J+ML);
  for I:=I0 to I1 do
   begin
    K := I - J + M;
    Z[K-1] := A[(I-1)+(J-1)*MA];
_60:
   end;
  S := 0.0e0;
  for I:=I0 to I1 do
   begin
    K := I - J + M;
    A[(K-1)+(J-1)*MA] := Z[K-1];
    S := S + Abs(Z[K-1]);
_70:
   end;
  if ( S > ANORM ) 
   then ANORM := S;
_80:
 end;
J0 := MU + 2;
J1 := Min0(N,M) - 1;
if ( J1 < J0 ) 
 then goto _110;
for JZ:=J0 to J1 do
 begin
  I0 := M + 1 - JZ;
  for I:=I0 to ML do
   begin
    A[(I-1)+(JZ-1)*MA] := 0.0e0;
_90:
   end;
_100:
 end;
_110:
JZ := J1;
JU := 0;
NM1 := N - 1;
if ( NM1 < 1 ) 
 then goto _310;
for K:=1 to NM1 do
 begin
  KP1 := K + 1;
  JZ := JZ + 1;
  if ( JZ > N ) 
   then goto _130;
  if ( ML < 1 ) 
   then goto _130;
  for I:=1 to ML do
   begin
    A[(I-1)+(JZ-1)*MA] := 0.0e0;
_120:
   end;
_130:
  LM := Min0(ML,N-K);
  L := M;
  S := Abs(A[(M-1)+(K-1)*MA]);
  I0 := M + 1;
  I1 := M + LM;
  for I:=I0 to I1 do
   begin
    if ( Abs(A[(I-1)+(K-1)*MA]) <= S ) 
     then goto _140;
    L := I;
    S := Abs(A[(I-1)+(K-1)*MA]);
_140:
_150:
   end;
  NLEAD[K-1] := L + K - M;
  if ( A[(L-1)+(K-1)*MA] = 0.0e0 ) 
   then goto _280;
  if ( L = M ) 
   then goto _160;
  T := A[(L-1)+(K-1)*MA];
  A[(L-1)+(K-1)*MA] := A[(M-1)+(K-1)*MA];
  A[(M-1)+(K-1)*MA] := T;
_160:
  T := -1.e0/A[(M-1)+(K-1)*MA];
  I0 := M + 1;
  I1 := M + LM;
  I := (LM Mod 5) + M;
  if ( I = M ) 
   then goto _180;
  for J:=I0 to I do
   begin
    A[(J-1)+(K-1)*MA] := T*A[(J-1)+(K-1)*MA];
_170:
   end;
_180:
  I := I + 1;
  if ( I > I1 ) 
   then goto _200;
  J := I;
  while ( J<=I1 ) do
   begin
    A[(J-1)+(K-1)*MA] := T*A[(J-1)+(K-1)*MA];
    A[(J+0)+(K-1)*MA] := T*A[(J+0)+(K-1)*MA];
    A[(J+1)+(K-1)*MA] := T*A[(J+1)+(K-1)*MA];
    A[(J+2)+(K-1)*MA] := T*A[(J+2)+(K-1)*MA];
    A[(J+3)+(K-1)*MA] := T*A[(J+3)+(K-1)*MA];
_190:
    inc(J,5);
   end;
_200:
  JU := Min0(Max0(JU,MU+NLEAD[K-1]),N);
  MM := M;
  if ( JU < KP1 ) 
   then goto _270;
  for J:=KP1 to JU do
   begin
    L := L - 1;
    MM := MM - 1;
    T := A[(L-1)+(J-1)*MA];
    if ( L = MM ) 
     then goto _210;
    A[(L-1)+(J-1)*MA] := A[(MM-1)+(J-1)*MA];
    A[(MM-1)+(J-1)*MA] := T;
_210:
    I0 := M + 1;
    I1 := M + LM;
    I := (LM Mod 4) + M;
    if ( I = M ) 
     then goto _230;
    for JJ:=I0 to I do
     begin
      KB := JJ + MM - M;
      A[(KB-1)+(J-1)*MA] := A[(KB-1)+(J-1)*MA] + T*A[(JJ-1)+(K-1)*MA];
_220:
     end;
_230:
    I := I + 1;
    if ( I > I1 ) 
     then goto _250;
    JJ := I;
    while ( JJ<=I1 ) do
     begin
      KB := JJ + MM - M;
      A[(KB-1)+(J-1)*MA] := A[(KB-1)+(J-1)*MA] + T*A[(JJ-1)+(K-1)*MA];
      A[(KB+0)+(J-1)*MA] := A[(KB+0)+(J-1)*MA] + T*A[(JJ+0)+(K-1)*MA];
      A[(KB+1)+(J-1)*MA] := A[(KB+1)+(J-1)*MA] + T*A[(JJ+1)+(K-1)*MA];
      A[(KB+2)+(J-1)*MA] := A[(KB+2)+(J-1)*MA] + T*A[(JJ+2)+(K-1)*MA];
_240:
      inc(JJ,4);
     end;
_250:
_260:
   end;
_270:
  goto _290;
_280:
  IERR := -K;
_290:
_300:
 end;
_310:
if ( A[(M-1)+(N-1)*MA] = 0.0e0 ) 
 then IERR := -N;
NLEAD[N-1] := N;
if ( IERR = 0 ) 
 then goto _320;
UTAFSI('A','F','B','2','E',IERR);
goto _820;
_320:
EK := 1.e0;
for J:=1 to N do
 begin
  Z[J-1] := 0.0e0;
_330:
 end;
JU := 0;
for K:=1 to N do
 begin
  if ( Z[K-1] <> 0.e0 ) 
   then EK := Sign(EK,-Z[K-1]);
  if ( Abs(EK-Z[K-1]) <= Abs(A[(M-1)+(K-1)*MA]) ) 
   then goto _400;
  S := Abs(A[(M-1)+(K-1)*MA])/Abs(EK-Z[K-1]);
  LL := 390;
_340:
  I := (N Mod 5);
  if ( I = 0 ) 
   then goto _360;
  for JJ:=1 to I do
   begin
    Z[JJ-1] := S*Z[JJ-1];
_350:
   end;
  if ( N < 5 ) 
   then goto _380;
_360:
  I := I + 1;
  JJ := I;
  while ( JJ<=N ) do
   begin
    Z[JJ-1] := S*Z[JJ-1];
    Z[JJ+0] := S*Z[JJ+0];
    Z[JJ+1] := S*Z[JJ+1];
    Z[JJ+2] := S*Z[JJ+2];
    Z[JJ+3] := S*Z[JJ+3];
_370:
    inc(JJ,5);
   end;
_380:
  if ( LL=390 ) then goto _390 else
  if ( LL=540 ) then goto _540 else
  if ( LL=590 ) then goto _590 else
  if ( LL=630 ) then goto _630 else
  if ( LL=680 ) then goto _680 else
  if ( LL=720 ) then goto _720 else
  if ( LL=730 ) then goto _730 else
  if ( LL=810 ) then goto _810;
_390:
  EK := S*EK;
_400:
  WK := EK - Z[K-1];
  WKM := -EK - Z[K-1];
  S := Abs(WK);
  SM := Abs(WKM);
  if ( A[(M-1)+(K-1)*MA] = 0.0e0 ) 
   then goto _410;
  WK := WK/A[(M-1)+(K-1)*MA];
  WKM := WKM/A[(M-1)+(K-1)*MA];
  goto _420;
_410:
  WK := 1.e0;
  WKM := 1.e0;
_420:
  KP1 := K + 1;
  JU := Min0(Max0(JU,MU+NLEAD[K-1]),N);
  MM := M;
  if ( KP1 > JU ) 
   then goto _460;
  for J:=KP1 to JU do
   begin
    MM := MM - 1;
    SM := SM + Abs(Z[J-1] + WKM*A[(MM-1)+(J-1)*MA]);
    Z[J-1] := Z[J-1] + WK*A[(MM-1)+(J-1)*MA];
    S := S + Abs(Z[J-1]);
_430:
   end;
  if ( S >= SM ) 
   then goto _450;
  T := WKM - WK;
  WK := WKM;
  MM := M;
  for J:=KP1 to JU do
   begin
    MM := MM - 1;
    Z[J-1] := Z[J-1] + T*A[(MM-1)+(J-1)*MA];
_440:
   end;
_450:
_460:
  Z[K-1] := WK;
_470:
 end;
LL := 530;
_480:
S := 0.0e0;
I := (N Mod 6);
if ( I = 0 ) 
 then goto _500;
for JJ:=1 to I do
 begin
  S := S + Abs(Z[JJ-1]);
_490:
 end;
if ( N < 6 ) 
 then goto _520;
_500:
I := I + 1;
JJ := I;
while ( JJ<=N ) do
 begin
  S := S + Abs(Z[JJ-1]) + Abs(Z[JJ+0]) + Abs(Z[JJ+1]) +
   Abs(Z[JJ+2]) + Abs(Z[JJ+3]) + Abs(Z[JJ+4]);
_510:
  inc(JJ,6);
 end;
_520:
S := 1.0e0/S;
if ( LL=530 ) then goto _530 else
if ( LL=620 ) then goto _620 else
if ( LL=710 ) then goto _710 else
if ( LL=800 ) then goto _800;
_530:
LL := 540;
goto _340;
_540:
for KB:=1 to N do
 begin
  K := N + 1 - KB;
  LM := Min0(ML,N-K);
  if ( K >= N ) 
   then goto _580;
  I0 := M + 1;
  I1 := M + LM;
  I := (LM Mod 5) + M;
  if ( I = M ) 
   then goto _560;
  for JJ:=I0 to I do
   begin
    KP1 := JJ + K - M;
    Z[K-1] := Z[K-1] + A[(JJ-1)+(K-1)*MA]*Z[KP1-1];
_550:
   end;
_560:
  I := I + 1;
  if ( I > I1 ) 
   then goto _580;
  JJ := I;
  while ( JJ<=I1 ) do
   begin
    KP1 := JJ + K - M;
    Z[K-1] := Z[K-1] + A[(JJ-1)+(K-1)*MA]*Z[KP1-1] + A[(JJ+0)+(K-1)*MA]*Z[KP1+0]
     + A[(JJ+1)+(K-1)*MA]*Z[KP1+1] + A[(JJ+2)+(K-1)*MA]*Z[KP1+2]
     + A[(JJ+3)+(K-1)*MA]*Z[KP1+3];
_570:
    inc(JJ,5);
   end;
_580:
  if ( Abs(Z[K-1]) <= 1.0e0 ) 
   then goto _600;
  S := 1.0e0/Abs(Z[K-1]);
  LL := 590;
  goto _340;
_590:
_600:
  L := NLEAD[K-1];
  T := Z[L-1];
  Z[L-1] := Z[K-1];
  Z[K-1] := T;
_610:
 end;
LL := 620;
goto _480;
_620:
LL := 630;
goto _340;
_630:
YNORM := 1.e0;
for K:=1 to N do
 begin
  L := NLEAD[K-1];
  T := Z[L-1];
  Z[L-1] := Z[K-1];
  Z[K-1] := T;
  LM := Min0(ML,N-K);
  if ( K >= N ) 
   then goto _670;
  I0 := M + 1;
  I1 := M + LM;
  I := (LM Mod 4) + M;
  if ( I = M ) 
   then goto _650;
  for JJ:=I0 to I do
   begin
    KP1 := JJ + K - M;
    Z[KP1-1] := Z[KP1-1] + T*A[(JJ-1)+(K-1)*MA];
_640:
   end;
_650:
  I := I + 1;
  if ( I > I1 ) 
   then goto _670;
  JJ := I;
  while ( JJ<=I1 ) do
   begin
    KP1 := JJ + K - M;
    Z[KP1-1] := Z[KP1-1] + T*A[(JJ-1)+(K-1)*MA];
    Z[KP1+0] := Z[KP1+0] + T*A[(JJ+0)+(K-1)*MA];
    Z[KP1+1] := Z[KP1+1] + T*A[(JJ+1)+(K-1)*MA];
    Z[KP1+2] := Z[KP1+2] + T*A[(JJ+2)+(K-1)*MA];
_660:
    inc(JJ,4);
   end;
_670:
  if ( Abs(Z[K-1]) <= 1.0e0 ) 
   then goto _690;
  S := 1.0e0/Abs(Z[K-1]);
  LL := 680;
  goto _340;
_680:
  YNORM := S*YNORM;
_690:
_700:
 end;
LL := 710;
goto _480;
_710:
LL := 720;
goto _340;
_720:
YNORM := S*YNORM;
for KB:=1 to N do
 begin
  K := N + 1 - KB;
  if ( Abs(Z[K-1]) <= Abs(A[(M-1)+(K-1)*MA]) ) 
   then goto _740;
  S := Abs(A[(M-1)+(K-1)*MA])/Abs(Z[K-1]);
  LL := 730;
  goto _340;
_730:
  YNORM := S*YNORM;
_740:
  if ( A[(M-1)+(K-1)*MA] <> 0.e0 ) 
   then Z[K-1] := Z[K-1]/A[(M-1)+(K-1)*MA];
  if ( A[(M-1)+(K-1)*MA] = 0.e0 ) 
   then Z[K-1] := 1.e0;
  T := -Z[K-1];
  LM := Min0(K,M) - 1;
  if ( LM < 1 ) 
   then goto _780;
  I0 := M - LM;
  I1 := M - 1;
  I := (LM Mod 4) + I0 - 1;
  if ( I < I0 ) 
   then goto _760;
  for JJ:=I0 to I do
   begin
    KP1 := JJ + K - M;
    Z[KP1-1] := Z[KP1-1] + T*A[(JJ-1)+(K-1)*MA];
_750:
   end;
_760:
  I := I + 1;
  if ( I > I1 ) 
   then goto _780;
  JJ := I;
  while ( JJ<=I1 ) do
   begin
    KP1 := JJ + K - M;
    Z[KP1-1] := Z[KP1-1] + T*A[(JJ-1)+(K-1)*MA];
    Z[KP1+0] := Z[KP1+0] + T*A[(JJ+0)+(K-1)*MA];
    Z[KP1+1] := Z[KP1+1] + T*A[(JJ+1)+(K-1)*MA];
    Z[KP1+2] := Z[KP1+2] + T*A[(JJ+2)+(K-1)*MA];
_770:
    inc(JJ,4);
   end;
_780:
_790:
 end;
LL := 800;
goto _480;
_800:
LL := 810;
goto _340;
_810:
YNORM := S*YNORM;
if ( ANORM <> 0.e0 ) 
 then RCOND := YNORM/ANORM;
_820:
for J:=1 to N do
 begin
  I0 := Max0(1,J-MU-ML);
  I1 := Min0(N,J+ML);
  for I:=I0 to I1 do
   begin
    K := I - J + M;
    Z[I-1] := A[(K-1)+(J-1)*MA];
    A[(K-1)+(J-1)*MA] := 0.0e0;
_830:
   end;
  for I:=I0 to I1 do
   begin
    A[(I-1)+(J-1)*MA] := Z[I-1];
_840:
   end;
_850:
 end;
for I:=1 to N do
 begin
  J0 := Max0(1,I-ML);
  J1 := Min0(N,I+MU+ML);
  for J:=J0 to J1 do
   begin
    K := J - I + ML + 1;
    Z[K-1] := A[(I-1)+(J-1)*MA];
    A[(I-1)+(J-1)*MA] := 0.0e0;
_860:
   end;
  for J:=J0 to J1 do
   begin
    K := J - I + ML + 1;
    A[(I-1)+(K-1)*MA] := Z[K-1];
_870:
   end;
_880:
 end;
_890:
end;

end.
